const showWarning = () => {
	document.getElementById('desc').classList.add('displayNone');
	document.getElementById('warn').classList.remove('displayNone');
};
const removeWarning = () => {
	document.getElementById('desc').classList.remove('displayNone');
	document.getElementById('warn').classList.add('displayNone');
};

const disableButton = () => {
	const btnSave = document.getElementById('btnSave');
	btnSave.setAttribute('disabled', '');
	btnSave.classList.add('buttonGray');
	document.body.style.cursor = 'wait';
};

const enableButton = () => {
	const btnSave = document.getElementById('btnSave');
	btnSave.removeAttribute('disabled');
	btnSave.classList.remove('buttonGray');
	document.body.style.cursor = 'default';
};

// ---

document.getElementById('lbadminURL').value =
	LBTray.getServerURL() || LBTray.getPreviousServerURL();

if (LBTray.getServerURL()) {
	showWarning();
}

const saveURL = async () => {
	let newURL = document.getElementById('lbadminURL').value;

	if (newURL) newURL = newURL.replace(/(^(http|https):(\/\/))|(\/.*$)/g, '');

	removeWarning();
	disableButton();

	const start = +new Date();
	const isLBAdmin = await LBTray.checkServer(newURL);
	const end = +new Date();
	if ((end - start) < 1000) {
		// user needs to see that something has happened
		await new Promise((resolve) => {
			setTimeout(resolve, 800);
		});
	}

	enableButton();

	if (isLBAdmin) {
		LBTray.setServerURL(newURL);
	} else {
		showWarning();
	}
};
document.getElementById('lbadminURL').addEventListener('keydown', (e) => {
	if (e.code === 'Enter') {
		saveURL();
	}
});

const closeWindow = () => {
	LBTray.hideMainWindow();
};
